/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <compiz.h>

#define _FAKEARGB_OPTIONS_INTERNAL
#include "fakeargb_options.h"

static int displayPrivateIndex;

static CompMetadata fakeargbOptionsMetadata;

static CompPluginVTable *fakeargbPluginVTable = NULL;
CompPluginVTable fakeargbOptionsVTable;

#define GET_FAKEARGB_OPTIONS_DISPLAY(d) \
        ((FakeargbOptionsDisplay *) (d)->privates[displayPrivateIndex].ptr)

#define FAKEARGB_OPTIONS_DISPLAY(d) \
        FakeargbOptionsDisplay *od = GET_FAKEARGB_OPTIONS_DISPLAY (d)

#define GET_FAKEARGB_OPTIONS_SCREEN(s, od) \
        ((FakeargbOptionsScreen *) (s)->privates[(od)->screenPrivateIndex].ptr)

#define FAKEARGB_OPTIONS_SCREEN(s) \
        FakeargbOptionsScreen *os = GET_FAKEARGB_OPTIONS_SCREEN (s, GET_FAKEARGB_OPTIONS_DISPLAY (s->display))

typedef struct _FakeargbOptionsDisplay
{
    int screenPrivateIndex;

    CompOption opt[FakeargbDisplayOptionNum];
    fakeargbDisplayOptionChangeNotifyProc notify[FakeargbDisplayOptionNum];
} FakeargbOptionsDisplay;

typedef struct _FakeargbOptionsScreen
{
} FakeargbOptionsScreen;

CompAction * fakeargbGetWindowToggle (CompDisplay *d)
{
    FAKEARGB_OPTIONS_DISPLAY(d);
    return &od->opt[FakeargbDisplayOptionWindowToggle].value.action;
}

void fakeargbSetWindowToggleInitiate (CompDisplay *d, CompActionCallBackProc init)
{
    FAKEARGB_OPTIONS_DISPLAY(d);
    od->opt[FakeargbDisplayOptionWindowToggle].value.action.initiate = init;
}

void fakeargbSetWindowToggleTerminate (CompDisplay *d, CompActionCallBackProc term)
{
    FAKEARGB_OPTIONS_DISPLAY(d);
    od->opt[FakeargbDisplayOptionWindowToggle].value.action.terminate = term;
}

CompOption * fakeargbGetWindowToggleOption (CompDisplay *d)
{
    FAKEARGB_OPTIONS_DISPLAY(d);
    return &od->opt[FakeargbDisplayOptionWindowToggle];
}

void fakeargbSetWindowToggleNotify (CompDisplay *d, fakeargbDisplayOptionChangeNotifyProc notify)
{
    FAKEARGB_OPTIONS_DISPLAY(d);
    od->notify[FakeargbDisplayOptionWindowToggle] = notify;
}

CompOption * fakeargbGetDisplayOption (CompDisplay *d, FakeargbDisplayOptions num)
{
    FAKEARGB_OPTIONS_DISPLAY(d);
    return &od->opt[num];
}

static const CompMetadataOptionInfo fakeargbOptionsDisplayOptionInfo[] = {
    { "window_toggle", "action", 0, 0, 0 },
};

static Bool fakeargbOptionsSetDisplayOption (CompPlugin *plugin, CompDisplay *d, char *name, CompOptionValue *value)
{
    FAKEARGB_OPTIONS_DISPLAY(d);
    CompOption *o;
    int        index;

    o = compFindOption (od->opt, FakeargbDisplayOptionNum, name, &index);

    if (!o)
        return FALSE;

    switch (index)
    {
     case FakeargbDisplayOptionWindowToggle:
        if (compSetDisplayOption (d, o, value))
        {
            if (od->notify[FakeargbDisplayOptionWindowToggle])
                (*od->notify[FakeargbDisplayOptionWindowToggle]) (d, o, FakeargbDisplayOptionWindowToggle);
            return TRUE;
        }
        break;
    default:
        break;
    }
    return FALSE;
}

static CompOption * fakeargbOptionsGetDisplayOptions (CompPlugin *plugin, CompDisplay *d, int *count)
{
    FAKEARGB_OPTIONS_DISPLAY(d);
    *count = FakeargbDisplayOptionNum;
    return od->opt;
}

static Bool fakeargbOptionsInitScreen (CompPlugin *p, CompScreen *s)
{
    FakeargbOptionsScreen *os;
    
    FAKEARGB_OPTIONS_DISPLAY (s->display);

    os = calloc (1, sizeof(FakeargbOptionsScreen));
    if (!os)
        return FALSE;

    s->privates[od->screenPrivateIndex].ptr = os;

        if (fakeargbPluginVTable && fakeargbPluginVTable->initScreen)
        return fakeargbPluginVTable->initScreen (p, s);
    return TRUE;
}

static void fakeargbOptionsFiniScreen (CompPlugin *p, CompScreen *s)
{
    if (fakeargbPluginVTable && fakeargbPluginVTable->finiScreen)
        return fakeargbPluginVTable->finiScreen (p, s);

    FAKEARGB_OPTIONS_SCREEN (s);

    free (os);
}

static Bool fakeargbOptionsInitDisplay (CompPlugin *p, CompDisplay *d)
{
    FakeargbOptionsDisplay *od;
   
    
    od = calloc (1, sizeof(FakeargbOptionsDisplay));
    if (!od)
        return FALSE;

    od->screenPrivateIndex = allocateScreenPrivateIndex(d);
    if (od->screenPrivateIndex < 0)
    {
        free(od);
        return FALSE;
    }

    d->privates[displayPrivateIndex].ptr = od;

    if (!compInitDisplayOptionsFromMetadata (d, &fakeargbOptionsMetadata, fakeargbOptionsDisplayOptionInfo, od->opt, FakeargbDisplayOptionNum))
    {
        free (od);
        return FALSE;
    }
    if (fakeargbPluginVTable && fakeargbPluginVTable->initDisplay)
        return fakeargbPluginVTable->initDisplay (p, d);
    return TRUE;
}

static void fakeargbOptionsFiniDisplay (CompPlugin *p, CompDisplay *d)
{
    if (fakeargbPluginVTable && fakeargbPluginVTable->finiDisplay)
        return fakeargbPluginVTable->finiDisplay (p, d);

    FAKEARGB_OPTIONS_DISPLAY (d);

    freeScreenPrivateIndex(d, od->screenPrivateIndex);

    compFiniDisplayOptions (d, od->opt, FakeargbDisplayOptionNum);

    free (od);
}

static Bool fakeargbOptionsInit (CompPlugin *p)
{
    displayPrivateIndex = allocateDisplayPrivateIndex();
    if (displayPrivateIndex < 0)
        return FALSE;

    if (!compInitPluginMetadataFromInfo (&fakeargbOptionsMetadata, "fakeargb",fakeargbOptionsDisplayOptionInfo, FakeargbDisplayOptionNum, 0, 0))
        return FALSE;

    compAddMetadataFromFile (&fakeargbOptionsMetadata, "fakeargb");
    if (fakeargbPluginVTable && fakeargbPluginVTable->init)
        return fakeargbPluginVTable->init (p);
    return TRUE;
}

static void fakeargbOptionsFini (CompPlugin *p)
{
    if (fakeargbPluginVTable && fakeargbPluginVTable->fini)
        return fakeargbPluginVTable->fini (p);

    if (displayPrivateIndex >= 0)
        freeDisplayPrivateIndex(displayPrivateIndex);

    compFiniMetadata (&fakeargbOptionsMetadata);
}

static CompMetadata *
fakeargbOptionsGetMetadata (CompPlugin *plugin)
{
    return &fakeargbOptionsMetadata;
}

CompPluginVTable *getCompPluginInfo (void)
{
    if (!fakeargbPluginVTable)
    {
        fakeargbPluginVTable = fakeargbOptionsGetCompPluginInfo ();
        memcpy(&fakeargbOptionsVTable, fakeargbPluginVTable, sizeof(CompPluginVTable));
        fakeargbOptionsVTable.getMetadata = fakeargbOptionsGetMetadata;
        fakeargbOptionsVTable.init = fakeargbOptionsInit;
        fakeargbOptionsVTable.fini = fakeargbOptionsFini;
        fakeargbOptionsVTable.initDisplay = fakeargbOptionsInitDisplay;
        fakeargbOptionsVTable.finiDisplay = fakeargbOptionsFiniDisplay;
        fakeargbOptionsVTable.initScreen = fakeargbOptionsInitScreen;
        fakeargbOptionsVTable.finiScreen = fakeargbOptionsFiniScreen;
        fakeargbOptionsVTable.getDisplayOptions = fakeargbOptionsGetDisplayOptions;
	fakeargbOptionsVTable.setDisplayOption = fakeargbOptionsSetDisplayOption;
	
    }
    return &fakeargbOptionsVTable;
}

