/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _TILE_OPTIONS_H
#define _TILE_OPTIONS_H

#ifndef _TILE_OPTIONS_INTERNAL
#define getCompPluginInfo tileOptionsGetCompPluginInfo
#endif

#ifdef  __cplusplus
extern "C" {
#endif

CompPluginVTable *tileOptionsGetCompPluginInfo (void);

typedef enum
{
    TileDisplayOptionAnimateType,
    TileDisplayOptionAnimationDuration,
    TileDisplayOptionTileToggleType,
    TileDisplayOptionTileJoin,
    TileDisplayOptionTileDelta,
    TileDisplayOptionTileLeftOccupancy,
    TileDisplayOptionExcludeMatch,
    TileDisplayOptionTileVertically,
    TileDisplayOptionTileHorizontally,
    TileDisplayOptionTileTile,
    TileDisplayOptionTileCascade,
    TileDisplayOptionTileRestore,
    TileDisplayOptionTileToggle,
    TileDisplayOptionNum
} TileDisplayOptions;

typedef void (*tileDisplayOptionChangeNotifyProc) (CompDisplay *display, CompOption *opt, TileDisplayOptions num);

CompOption *tileGetDisplayOption (CompDisplay *d, TileDisplayOptions num);

typedef enum
{
    TileScreenOptionNum
} TileScreenOptions;

typedef void (*tileScreenOptionChangeNotifyProc) (CompScreen *screen, CompOption *opt, TileScreenOptions num);

CompOption *tileGetScreenOption (CompScreen *s, TileScreenOptions num);

typedef enum
{
    AnimateTypeNone = 0,
    AnimateTypeFilledOutline = 1,
    AnimateTypeSlide = 2,
    AnimateTypeZoom = 3,
    AnimateTypeDropFromTop = 4,
    AnimateTypeFade = 5,
} TileAnimateTypeEnum;

typedef enum
{
    TileToggleTypeTile = 0,
    TileToggleTypeLeft = 1,
    TileToggleTypeTileVertically = 2,
    TileToggleTypeTileHorizontally = 3,
    TileToggleTypeCascade = 4,
} TileTileToggleTypeEnum;

int              tileGetAnimateType (CompDisplay *d);
CompOption *     tileGetAnimateTypeOption (CompDisplay *d);
void             tileSetAnimateTypeNotify (CompDisplay *d, tileDisplayOptionChangeNotifyProc notify);
            
int              tileGetAnimationDuration (CompDisplay *d);
CompOption *     tileGetAnimationDurationOption (CompDisplay *d);
void             tileSetAnimationDurationNotify (CompDisplay *d, tileDisplayOptionChangeNotifyProc notify);
            
int              tileGetTileToggleType (CompDisplay *d);
CompOption *     tileGetTileToggleTypeOption (CompDisplay *d);
void             tileSetTileToggleTypeNotify (CompDisplay *d, tileDisplayOptionChangeNotifyProc notify);
            
Bool             tileGetTileJoin (CompDisplay *d);
CompOption *     tileGetTileJoinOption (CompDisplay *d);
void             tileSetTileJoinNotify (CompDisplay *d, tileDisplayOptionChangeNotifyProc notify);
            
int              tileGetTileDelta (CompDisplay *d);
CompOption *     tileGetTileDeltaOption (CompDisplay *d);
void             tileSetTileDeltaNotify (CompDisplay *d, tileDisplayOptionChangeNotifyProc notify);
            
int              tileGetTileLeftOccupancy (CompDisplay *d);
CompOption *     tileGetTileLeftOccupancyOption (CompDisplay *d);
void             tileSetTileLeftOccupancyNotify (CompDisplay *d, tileDisplayOptionChangeNotifyProc notify);
            
CompMatch *      tileGetExcludeMatch (CompDisplay *d);
CompOption *     tileGetExcludeMatchOption (CompDisplay *d);
void             tileSetExcludeMatchNotify (CompDisplay *d, tileDisplayOptionChangeNotifyProc notify);
            
CompAction *     tileGetTileVertically (CompDisplay *d);
void             tileSetTileVerticallyInitiate (CompDisplay *d, CompActionCallBackProc init);
void             tileSetTileVerticallyTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     tileGetTileVerticallyOption (CompDisplay *d);
void             tileSetTileVerticallyNotify (CompDisplay *d, tileDisplayOptionChangeNotifyProc notify);
            
CompAction *     tileGetTileHorizontally (CompDisplay *d);
void             tileSetTileHorizontallyInitiate (CompDisplay *d, CompActionCallBackProc init);
void             tileSetTileHorizontallyTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     tileGetTileHorizontallyOption (CompDisplay *d);
void             tileSetTileHorizontallyNotify (CompDisplay *d, tileDisplayOptionChangeNotifyProc notify);
            
CompAction *     tileGetTileTile (CompDisplay *d);
void             tileSetTileTileInitiate (CompDisplay *d, CompActionCallBackProc init);
void             tileSetTileTileTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     tileGetTileTileOption (CompDisplay *d);
void             tileSetTileTileNotify (CompDisplay *d, tileDisplayOptionChangeNotifyProc notify);
            
CompAction *     tileGetTileCascade (CompDisplay *d);
void             tileSetTileCascadeInitiate (CompDisplay *d, CompActionCallBackProc init);
void             tileSetTileCascadeTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     tileGetTileCascadeOption (CompDisplay *d);
void             tileSetTileCascadeNotify (CompDisplay *d, tileDisplayOptionChangeNotifyProc notify);
            
CompAction *     tileGetTileRestore (CompDisplay *d);
void             tileSetTileRestoreInitiate (CompDisplay *d, CompActionCallBackProc init);
void             tileSetTileRestoreTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     tileGetTileRestoreOption (CompDisplay *d);
void             tileSetTileRestoreNotify (CompDisplay *d, tileDisplayOptionChangeNotifyProc notify);
            
CompAction *     tileGetTileToggle (CompDisplay *d);
void             tileSetTileToggleInitiate (CompDisplay *d, CompActionCallBackProc init);
void             tileSetTileToggleTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     tileGetTileToggleOption (CompDisplay *d);
void             tileSetTileToggleNotify (CompDisplay *d, tileDisplayOptionChangeNotifyProc notify);
            
#ifdef  __cplusplus
}
#endif

#endif
